import { Assets, Ticker } from 'pixi.js';
import ReelsMachine from 'src/slotMachines/ReelsMachine';
import { STATES } from 'src/states/BasicStateMachine';
import { argTypes, getDefaultArgs } from 'src/stories/utils/argTypes';
import { createScreenInputMap } from 'src/stories/utils/createScreenInputMap';
import MachineContainer from 'src/stories/utils/MachineContainer';
import { centerView } from 'src/stories/utils/resize';
import AnimatedExpandedSymbolsSystem from 'src/systems/AnimatedExpandedSymbolsSystem';
import { SlotMachineConfig } from 'src/types/SlotMachineConfig';
import { Meta, PixiStory, StoryFn } from '@pixi/storybook-renderer';
import MockSystem from "src/systems/MockSystem";

const args = {
    key: 'K',
    zIndex: 4,
};

const meta: Meta<typeof AnimatedExpandedSymbolsSystem> = {
    title: 'Systems/ExpandingSpinSystem',
    tags: ['autodocs'],
    parameters: {
        docs: {
            story: {
                height: 600
            },
            description: {
                component: 'Expanding symbols mechanics.'
            },
        }
    },
    argTypes: argTypes(args),
    args: getDefaultArgs(args),
};

export default meta;

export const ReelsMachineStory: StoryFn<typeof args> = (_params, context) => new PixiStory({
    context, init: async (view) =>
    {
        Assets.reset();
        await Assets.init({
            manifest: 'area69/manifest.json',
        });
        await Assets.loadBundle('configs');
        await Assets.loadBundle('symbols');
        const config: SlotMachineConfig = Assets.get('slot_machine_config');
        const machine = new ReelsMachine(config);
        const container = new MachineContainer(machine);
        machine.systems.blockExitState = new MockSystem(machine)
        view.addChild(container);
        context.machine = machine;
        machine.systems.expanding = new AnimatedExpandedSymbolsSystem(machine);
        machine.stateMachine.states[STATES.SPINNING].systems = ['layering', 'spin', 'expanding'];
        machine.inputs.initMap = createScreenInputMap(config);
        machine.inputs.screenMap = machine.inputs.initMap;
        machine.systems.expanding.setSettings(_params);
        machine.inputs.spin = true;

        machine.inputs.blockExitState = true;
        setTimeout(() => {
            machine.inputs.blockExitState = false;
        }, 250);
        centerView(view);
    },
    resize: centerView,
    update: () =>
    {
        context.machine && context.machine.update(Ticker.shared.deltaMS);
    }
});
